'
' This script is used to clean the registry using data found in the .REG file
' created by my PRogram Installation MOnitor program. If you run this script as
' an administrator, it may clean the registry better than running the .REG
' file with regedit.
' To use this script, create a shortcut to wherever you put it in the SENDTO
' right-click folder in "C:\Users\<userid>\AppData\Roaming\Microsoft\Windows\SendTo"
' To run as an administrator, the "Target" in Properties/Shortcut must be something like...
' C:\WINDOWS\system32\cscript.exe "J:\Primo for Win8\Clean_registry.vbs"
' then you can left-click on "Advanced" near the bottom, and then 
' click on "Run as Administrator" to set it.
'
OPTION EXPLICIT     ' this forces all variables to be defined, not just SET
'
' Constants (taken from WinReg.h)
'
Const HKEY_CLASSES_ROOT   = &H80000000
Const HKEY_CURRENT_USER   = &H80000001
Const HKEY_LOCAL_MACHINE  = &H80000002
Const HKEY_USERS          = &H80000003
Const ForReading = 1
'   ROOTKEY  [ HKLM | HKCU | HKCR | HKU | HKCC ]
 
Dim debug
    debug = 0       ' set to 1 to get debug info...
Dim nodelete
    nodelete = 0       ' set to 1 to NOT delete registry entries...

WScript.Interactive = True     ' make sure we can interact with the screen

Dim in_count, strNextLine, input_record, line_lth
Dim MyMsg, key_value, name, key_code, del_code
Dim wsh, arrSubKeys, oReg, temp, strComputer, ts
Dim hDefKey, filename, strKeyPath, fs, objArgs, i
Dim strData, MyPos, ctr, restart, msg, rc, strSubkey
Dim clean_ctr

set wsh = WScript.CreateObject("Wscript.Shell")
set fs = CreateObject("Scripting.FileSystemObject")
set objArgs = wscript.arguments

' get the input file name

filename = allparameters
'if filename = "" then installation

    If filename = "" Then
      temp = ".REG file not specified : " & vbcrlf
      temp = temp & vbcrlf
      temp = temp & "Enter .REG file name..." & vbcrlf
      temp = temp & vbcrlf
      filename = InputBox(temp, "Enter .REG file name", "*.REG")
      If filename = "" Then WScript.Quit(99)        'if still no strDir,  we can't continue
    End If
If debug = 1 Then WScript.Echo "Debug b1, filename=" & filename

'msgbox "Debug 1, Click Yes to continue", vbYesNo + vbQuestion, "Remove?"    'rh

if not fs.fileexists(filename) then
msgbox "The file " & filename & " does not exist", vbCritical, "Error"
wscript.quit
end if

clean_ctr = 0

      temp = "" 'vbcrlf
'      temp = temp & vbcrlf
      temp = temp & "Do you really want to clean " & vbcrlf
      temp = temp & "the registry using data in file " &vbcrlf
      temp = temp & filename & vbcrlf
      temp = MsgBox (temp, vbYesNo+vbQuestion+vbDefaultButton1, "Clean Registry")
      If temp = vbNo Then WScript.Quit(99)        'user clicked CANCEL

' Choose computer name, registry tree and key path
'
strComputer = "." ' Use . for current machine
hDefKey = HKEY_LOCAL_MACHINE
'strKeyPath = "SOFTWARE\Microsoft\Cryptography\Defaults\Provider"
strKeyPath = "SOFTWARE\Microsoft\Windows NT\CurrentVersion"

' Connect to registry provider on target machine with current user
'
Set oReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\default:StdRegProv")

' open .reg file and process it
Set ts = fs.OpenTextFile(filename, ForReading)
strData = " "
   
' Do loop 1
Do Until ts.AtEndOfStream        ' read input file

' Do loop 2
  Do
    strData = ts.Readline
    in_count = in_count + 1
    input_record = strData
	line_lth = Len(input_record)
	
	If line_lth = 0 Then 
		line_lth = 1      ' blank line...
		input_record = " "
	End If	
	If debug = 1 Then 
		Wscript.Echo "Debug 200: record: " & in_count & "=" & input_record 
	End If

        MyPos = 0
        MyMsg = ""

' label copy clean 1
		MyPos = Instr(1, input_record, "[", 1)   '  see if data starts with [
'		If debug = 1 Then 
'			Wscript.Echo "Debug 2800: " & MyPos & ",  " & input_record
'		End If
		If MyPos = 1 Then               ' yes it is
           ctr = ctr + 1
           MyPos = Instr(2, input_record, "-", 1)   '  see if data starts with [-
		   If MyPos = 2 Then               ' yes it is
              MyMsg = "strData= " & strData & vbCrLf
              name = mid(strData, 3, Len(strData)-3)
              MyMsg = MyMsg & "name= " & name & vbCrLf
              If debug = 1 Then msgbox MyMsg, vbCritical, "Names"
              Process_key(name)
           Else
              MyMsg = "strData= " & strData & vbCrLf
              name = mid(strData, 2, Len(strData)-2)
              MyMsg = MyMsg & "name= " & name & vbCrLf
              strData = ts.Readline   ' read value line
              restart = strData
'              restart = mid(strData, 2, Len(strData)-2)
              MyMsg = MyMsg & "restart= " & restart & vbCrLf
              If debug = 1 Then msgbox MyMsg, vbOk, "Value"
'              msgbox MyMsg, vbCritical, "Value"
              Process_value name, key_value, restart
           End If

'           MyMsg = MyMsg & input_record & vbCrLf
			If debug = 1 Then 
'				Wscript.Echo "Debug 2900: " & MyPos & input_record
			End If
		End If    'If MyPos = 1

  Loop Until ts.AtEndOfStream    ' end of Do loop 2 

Loop  ' end of Do loop 1

'   msgbox "strData= " & strData, vbCritical, "Error"
if name = "" then name = "(no name mentioned)"
ts.Close
Set ts = Nothing

'   Wscript.Echo clean_ctr & " Registry changes have been made."
   msgbox(clean_ctr & " Registry changes have been made.")
'msgbox "We got to here...", vbCritical, "Error"
'msgbox "name= " & name, vbCritical, "Error"
wscript.Quit         ' end of main routine

'=============== end for now ==============================




' ----- Global subroutines
function allparameters
' debug...
   If debug = 1 Then
      MyMsg = "Number of arguments = " & objArgs.Count
      If objArgs.Count > 0 Then
         For I = 0 to objArgs.Count - 1
             MyMsg = MyMsg & vbCrLf & objArgs(I)
         Next
      End If
      rc = MsgBox(MyMsg, vbInformation+vbOKOnly, "Passed Arguments")
   End If
   MyMsg = ""

   if objArgs.Count > 0 then
      allparameters = objArgs(0)
'      for i=1 to objArgs.Count-1
'      allparameters = allparameters & chr(32) & objArgs(i)
'      next
   end if
' debug...
   If debug = 1 Then
      MyMsg = "allparameters = " '& objArgs.Count
      MyMsg = MyMsg & vbCrLf & allparameters
      rc = MsgBox(MyMsg, vbInformation+vbOKOnly, "allparameters")
   End If
   MyMsg = ""
'filename = allparameters

end function

function Process_key(key)
    
    MyPos = Instr(1, key, "\", 1)   '  find 1st back slash
    If MyPos > 1 Then               ' yes it is
       hDefKey = Mid(key, 1, MyPos-1)
       strKeyPath = Mid(key, MyPos+1)
    End If    
'    hDefKey = split(key, "\")(1)
    MyMsg = "In Process_key," & vbCrLf
    MyMsg = MyMsg & "hDefKey= " & hDefKey & vbCrLf
    MyMsg = MyMsg & "strKeyPath= " & strKeyPath & vbCrLf
    If debug = 1 Then Wscript.Echo MyMsg 
    
' Try to enum the subkeys of the key path we've chosen. We can't if the key doesn't exist
'
'   ROOTKEY  [ HKLM | HKCU | HKCR | HKU | HKCC ]
    If hDefKey = "HKEY_CLASSES_ROOT" Or hDefKey = "HKCR" Then
       key_code = HKEY_CLASSES_ROOT
'       del_code = "HKCR"
    End If
    If hDefKey = "HKEY_CURRENT_USER" Or hDefKey = "HKCU" Then
       key_code = HKEY_CURRENT_USER
'       del_code = "HKCU"
    End If
    If hDefKey = "HKEY_LOCAL_MACHINE" Or hDefKey = "HKLM" Then
       key_code = HKEY_LOCAL_MACHINE
'       del_code = "HKLM"
    End If
    If hDefKey = "HKEY_USERS" Or hDefKey = "HKU" Then
       key_code = HKEY_USERS
'       del_code = "HKU"
    End If
    
'    If oReg.EnumKey(key_code, strKeyPath, arrSubKeys) = 0 Then
    rc = oReg.EnumKey(key_code, strKeyPath, arrSubKeys)
    If IsArray(arrSubkeys) Then 
        For Each strSubkey In arrSubkeys 
            WScript.Echo "Deleting " & hDefKey, strKeyPath & "\" & strSubkey 
        Next 
    End If 

    If rc = 0 Then
      If debug = 1 Then wscript.echo "Key exists!"
      DeleteSubkeys key_code, strKeypath 
    Else
'      If debug = 1 Then 
'        wscript.echo "Key does not exist."
        MyMsg = "Key does not exist. " & vbCrLf
        MyMsg = MyMsg & "key= " & hDefKey & "\" & strKeyPath & vbCrLf
        MyMsg = MyMsg & "return code= " & rc & vbCrLf
        MyMsg = MyMsg & "err_number= " & Err.Number & vbCrLf
'        If rc = 5 Then
'           MyMsg = MyMsg & "Access is denied"
'        End If
'        If rc = 2 Then
'           MyMsg = MyMsg & "Value not found"
'        End If
        wscript.echo MyMsg
      If debug = 1 Then 
        msgbox MyMsg, vbCritical, "Error"
      End If  
    End If

end function

function Process_value(name, key_value, del_value)
    Dim dv2
    MyMsg = "In Process_value," & vbCrLf
    MyMsg = MyMsg & "name= " & name & vbCrLf
    MyMsg = MyMsg & "key_value= " & key_value & vbCrLf
    MyMsg = MyMsg & "del_value= " & del_value & vbCrLf
    If debug = 1 Then Wscript.Echo MyMsg 
    MyPos = Instr(1, name, "\", 1)   '  find 1st back slash
    If MyPos > 1 Then               ' yes it is
       hDefKey = Mid(name, 1, MyPos-1)
       strKeyPath = Mid(name, MyPos+1)
    End If    
'    hDefKey = split(key, "\")(1)
    MyMsg = "In Process_value," & vbCrLf
    MyMsg = MyMsg & "hDefKey= " & hDefKey & vbCrLf
    MyMsg = MyMsg & "strKeyPath= " & strKeyPath & vbCrLf
    If debug = 1 Then Wscript.Echo MyMsg 

' process value to delete    
    MyPos = Instr(2, del_value, CHR(34), 1)   '  find 2nd quote (")
    If MyPos > 1 Then               ' yes it is
       dv2 = Mid(del_value, 2, MyPos-2)
    End If    
'    hDefKey = split(key, "\")(1)
    MyMsg = "In Process_value," & vbCrLf
    MyMsg = MyMsg & "dv2= " & dv2 & vbCrLf
    MyMsg = MyMsg & "strKeyPath= " & strKeyPath & vbCrLf
    If debug = 1 Then Wscript.Echo MyMsg 
    

    
' Try to enum the subkeys of the key path we've chosen. We can't if the key doesn't exist
'
'   ROOTKEY  [ HKLM | HKCU | HKCR | HKU | HKCC ]
    If hDefKey = "HKEY_CLASSES_ROOT" Or hDefKey = "HKCR" Then
       key_code = HKEY_CLASSES_ROOT
'       del_code = "HKCR"
    End If
    If hDefKey = "HKEY_CURRENT_USER" Or hDefKey = "HKCU" Then
       key_code = HKEY_CURRENT_USER
'       del_code = "HKCU"
    End If
    If hDefKey = "HKEY_LOCAL_MACHINE" Or hDefKey = "HKLM" Then
       key_code = HKEY_LOCAL_MACHINE
'       del_code = "HKLM"
    End If
    If hDefKey = "HKEY_USERS" Or hDefKey = "HKU" Then
       key_code = HKEY_USERS
'       del_code = "HKU"
    End If
    
     rc = 0    ' start with 0
'    oReg.DeleteValue HKEY_CURRENT_USER, strKeyPath, strValueName
     msg = "DeleteValue = " & key_code & strKeyPath & dv2
     If debug = 1 Then msgbox msg, vbOk, "Info"
     If nodelete = 0 Then
        rc = oReg.DeleteValue(key_code, strKeyPath, dv2)
     End If
     msg = " rc from reg delete value is..." & rc & vbCrLf
     If debug = 1 Then WScript.Echo " rc from reg delete value is..." & rc & " err_number=" & Err.Number
     If rc > 0 Then
        MyMsg = "Error deleting registry value " & vbCrLf
        MyMsg = MyMsg & "key= " & hDefKey & "\" & strKeyPath & vbCrLf
        MyMsg = MyMsg & "value= " & dv2 & vbCrLf
        MyMsg = MyMsg & "return code= " & rc & vbCrLf
        MyMsg = MyMsg & "err_number= " & Err.Number & vbCrLf
        If rc = 5 Then
           MyMsg = MyMsg & "1 - Access is denied"
        End If
        If rc = 2 Then
           MyMsg = MyMsg & "Value not found"
        End If
        Wscript.Echo MyMsg 
'        msgbox MyMsg, vbCritical, "Error"  ' comment this line to stop popup
     Else
        clean_ctr = clean_ctr + 1
     End If
end function

Sub DeleteSubkeys(del_code, strKeyPath) 
    oReg.EnumKey del_code, strKeyPath, arrSubkeys 
'    If oReg.EnumKey(key_code, strKeyPath, arrSubKeys) = 0 Then

    Err.Number = 0            ' set to 0
    If IsArray(arrSubkeys) Then 
        For Each strSubkey In arrSubkeys 
            If Err.Number <> 0 Then Exit For
            If debug = 1 Then WScript.Echo "Deleting " & del_code, strKeyPath & "\" & strSubkey 
            DeleteSubkeys del_code, strKeyPath & "\" & strSubkey 
        Next 
    End If 

    If debug = 1 Then WScript.Echo "Deleting " & del_code, strKeyPath
     If nodelete = 0 Then
        rc = oReg.DeleteKey(del_code, strKeyPath)
     End If
     msg = " rc from reg delete is..." & rc & vbCrLf
     If debug = 1 Then WScript.Echo " rc from reg delete is..." & rc & " err_number=" & Err.Number
     If rc > 0 Then
        MyMsg = "Error deleting registry entry " & vbCrLf
        MyMsg = MyMsg & "key= " & strKeyPath & vbCrLf
        MyMsg = MyMsg & "return code= " & rc & vbCrLf
        MyMsg = MyMsg & "err_number= " & Err.Number & vbCrLf
        If rc = 5 Then
           MyMsg = MyMsg & "2 - Access is denied"
        End If
'        msgbox MyMsg, vbCritical, "Error"  ' comment this line to stop popup
        Wscript.Echo MyMsg & "Error" & vbCRLf
     Else
        clean_ctr = clean_ctr + 1
     End If
End Sub
